#include "my_func.h"

//----   quicksort  -----
int compare(void const *s1,void const *s2){
return ((*(struct node **)s1)->s.tv) < ((*(struct node **)s2)->s.tv);
}

//---          ----
struct node *CmpNumber(struct node *footballs,int number){
	struct node *tmp=NULL;

	for(tmp=footballs; tmp ;tmp=tmp->next)
	{ 
		if((tmp->s.number) == number) return tmp;
	}
return NULL;
}

//----        .   ---
struct node * addFootball(struct node *footballs) 
{
	int flag=0,c,flag1=0,k,a;
	int q;
	char check[50];
	struct node *tmp=NULL;
	struct node *ind=NULL;

	//--   .      ---
	tmp=(struct node *) malloc(sizeof(struct node));
		if(!tmp) 
		{
			printf("\n    !\n");
			return footballs;
		}
	
	system("cls"); //--    --
	printf("<     >\n");

	//--------     ----------
	do 
	{
		fflush(stdin); //--    ---
		printf("\n:");
		k=scanf("%d",&a);
		if((k) && (a>0)) 
		{ 
			flag=1;
			if(! (ind=CmpNumber(footballs,a))) 
			{
				tmp->s.number=a; //--      ---
			}
			else 
			{
				printf("\n      !\n");
				printf("\n         ?");
				printf("\n '1'( )  '2' ( ):");
						do
						{
						c=getch();
						}
						while((c!='1') && (c!='2'));
						if(c=='1') 
						{
							flag1=1; 
							flag=1;
							free(tmp);
							tmp=ind;
							printf("\n");
						}
						else 
						{
							free(tmp); //----      
							printf("\n\n     -  ..\n");
							getch();
							system("cls");  //--   
							return footballs;
						}
			}
		}
		else printf("\n  -  ..."); 
	}
	while(!flag);

	//----------      -----------------
	flag=0;
	do 
	{
		fflush(stdin);
		printf(":");
		gets(check);
		if(!Check(check,0)) 
		{
			strcpy(tmp->s.name,check);
			flag=1;
		}
		else printf("\n  -  ...\n");
	}
	while(!flag);


	//-----------      -------------------
	do 
	{
		fflush(stdin);
		printf("  :");
		k=scanf("%d",&q);
		if(q<=0) k=0;
		if(k) tmp->s.koef=q;
		else	printf("\n  -  ...\n");
	}
	while(!k);
	
	//-----------      -------------------
	do 
	{
		fflush(stdin);
		printf("  :");
		k=scanf("%d",&tmp->s.team);
		if((!k) || ((tmp->s.team) < 0)) 
		{	printf("\n  -  ...\n"); k=0; }
	}
	while(!k);

	//---------------   - -----------------
	flag=0;
	do 
	{
		fflush(stdin);
		printf("-:");
		k=scanf("%d", &tmp->s.tv);
		if((!k) || ((tmp->s.tv) < 0))
		{ printf("\n  -  ...\n"); k=0;}
	}
	while(!k);

	//---------------        -----------------
	flag=0;
	do 
	{
		fflush(stdin);
		printf("   :");
		k=scanf("%d", &tmp->s.sredno);
		if((!k) || ((tmp->s.sredno) < 0))
		{ printf("\n  -  ...\n"); k=0;}
	}
	while(!k);

	if(flag1!=1)
	{
		tmp->next=footballs; //---      
		footballs=tmp; //---------    ...
	}
	printf("\n\n     -  ..\n");
	getch();
	system("cls");
return footballs;
}

//-------------       ---------
struct node * deleteFootball(struct node *footballs,struct node *football)
{
	struct node *tmp = NULL;
	if(footballs == football) 
	{
		footballs = footballs->next;
		free(football);
	}
	else 
	{
		for(tmp=footballs;  tmp ;tmp=tmp->next)
		{
			if(tmp->next == football) 
			{
				tmp->next=football->next;
				free(football);
			}
		}
	}
return footballs;
}

//---         ----
struct node *updateFootball(struct node *footballs,char name)
{
	struct node *tmp = NULL;
	int flag = 0,i,k;
	int q;
	char check[50];

	if(tmp=CmpNumber(footballs,number))
	{
		system("cls");
		printf("<       <%d>\n",number);
		//----------      -----------------
		flag=0;
		do 
		{
			for(i = 0;i < 50; i++) check[i] = '\0';
			fflush(stdin);
			printf(":");
			gets(check);
			if(!Check(check, 0)) 
			{
				strcpy(tmp->s.name, check);
				flag = 1;
			}
			else printf("\n  -  ...\n");
		}
		while(!flag);

		//-----------      -------------------
		do 
		{
			fflush(stdin);
			printf("  :");
			k=scanf("%d",&q);
			if(q<=0) k=0;
			if(k) tmp->s.koef=q;
			else	printf("\n  -  ...\n");
		}
		while(!k);
	
		//-----------      -------------------
		do 
		{
			fflush(stdin);
			printf("  :");
			k=scanf("%d",&tmp->s.team);
			if((!k) || ((tmp->s.team) < 0)) 
			{	printf("\n  -  ...\n"); k=0; }
		}
		while(!k);

		//---------------   - -----------------
		flag=0;
		do 
		{
			fflush(stdin);
			printf("-:");
			k=scanf("%d", &tmp->s.tv);
			if((!k) || ((tmp->s.tv) < 0))
			{ printf("\n  -  ...\n"); k=0;}
		}
		while(!k);

		//---------------        -----------------
		flag=0;
		do 
		{
			fflush(stdin);
			printf("   :");
			k=scanf("%d", &tmp->s.sredno);
			if((!k) || ((tmp->s.sredno) < 0))
			{ printf("\n  -  ...\n"); k=0;}
		}
		while(!flag);
	
		if(tmp->s.team == 0)
		{
			printf("\n          !!!");
			footballs = deleteFootball(footballs,tmp);
			printf("\n\n     -  ..\n");
			getch();
			system("cls");
		}
	}
	else printf("\n -       <%d>",number);
return footballs;
}



//-------     . ----------
struct node *del(struct node *head)
{
	struct node *tmp;
	while(head)
	{
		tmp=head;
		head=head->next;
		free(tmp);
	}
	return NULL;
}

//---      ------------
int menu( char *t[])
{	
	int k,i=1;
	char ch;
	printf ("\n%s\n",t[0]);
	while (t[i])  
		printf("\n<%d> - %s", i,t[i++]);
		printf ("\n\n:");
	do 
	{
		ch=getch();
		k=ch-'0';
	}
	while(k<=0 || k >i-1);
	printf("%c\n",ch);
	return k;
}

//---          - --
void ShowSortFootball(struct node *footballs, int tv)
{
	int cnt,a;
	struct node *tmp=NULL;
	struct node **Arr=NULL;

	for(cnt=0,tmp=footballs;tmp;tmp=tmp->next) cnt++;  //---    

	//-----          ----
	if(!(Arr=(struct node **) malloc(sizeof(struct node*) * cnt))) {	
			printf("\n  -     \n");
		}

	//------       -----
	for(cnt=0,tmp=footballs; tmp; tmp=tmp->next) Arr[cnt++]=tmp;  

	qsort((void *)Arr,cnt,sizeof(struct node*),compare); //-----    quicksort ---

	system("cls");
	printf("<  >");
	printf("\n|              |  |   | - |         ");
	printf("\n------------------------------------------------------------------------");
	for(a=0; a < cnt ;a++)
	{
		printf("\n| %15s ",Arr[a]->s.name);
		printf("| %5d ",Arr[a]->s.koef);
		printf("| %11.2d ",Arr[a]->s.team);
		printf("| %10d ",Arr[a]->s.tv);
		printf("| %15d ",Arr[a]->s.sredno);
	}
	printf("\n\n    -   !");
	getch();
	system("cls"); //---   ---
	if(Arr) free(Arr); //---         ---- 
}

//---             ---
void InfoFootball(struct node *footballs,int team)
{
	struct node *tmp=NULL;
	system("cls");
	printf("<  >");
	printf("\n|              |  |   | - |         ");
	printf("\n-----------------------------------------------------------------------");
	for(tmp=footballs; tmp;tmp=tmp->next) 
	{
		if(tmp->s.team > team)
		{
			printf("\n| %15s ",tmp->s.name);
			printf("| %5d ",tmp->s.koef);
			printf("| %11.2d ",tmp->s.team);
			printf("| %10d ",tmp->s.tv);
			printf("| %15d ",tmp->s.sredno);
		}
	}
	printf("\n\n    -   !");
	getch();
	system("cls"); //---   ---
}


//----         ---------
int SaveToBinary(FILE *fp,struct node *footballs)
{
	int l;
	struct node *tmp=NULL;
	for(tmp=footballs; tmp; tmp = tmp->next)
	{
		l=fwrite(&(tmp->s),1,sizeof(Football),fp);
			if (l != (sizeof(Football))) 
			{ 
				printf("\n -     !");
				return 1;
			}
	}
	return 0;
}
//---         ----
struct node *ReadBinary(FILE *fp,struct node *footballs)
{
	struct node *tmp=NULL;
	int l;
	rewind(fp);
	while(!feof(fp))
	{	
		tmp=(struct node*) malloc(sizeof(struct node));
		if(!tmp)
		{
			printf("\n     !\n");
			return footballs;	
		}
		l=fread(&(tmp->s),1,sizeof(Football),fp);
		if (l != (sizeof(Football))) 
		{
			free(tmp);
			return footballs;
		}
		tmp->next=footballs;
		footballs=tmp;
	}
	return footballs;
}

